var EventEmitter = require('events').EventEmitter;

var Repository = function() {
    var e = new EventEmitter();
    process.nextTick(function() {
        e.emit('connected');
        var items = ["A", "B", "C"];
        for (var i in items)
            e.emit('data', items[i]);
        e.emit('closed');
    });
    return e;
};

var r = new Repository();

r.on('connected', function() {
    console.log('Connected to database');
});

r.on('data', function(i) {
    console.log('Fetched:'+i);
});

r.on('closed', function() {
    console.log('Connection closed');
});