var util = require('util');
var EventEmitter = require('events').EventEmitter;

var Repository = function () {
    var self = this;
    process.nextTick(function() {
        self.emit('connected');
        var items = ["A", "B", "C"];
        for (var i in items)
            self.emit('data', items[i]);
        self.emit('closed');
    });
};

util.inherits(Repository, EventEmitter);
module.exports = Repository;