var count = 10;

var books = [
    {ID: 1, Title: "Obcy", Author: "Albert Camus", Rok: 1942},
    {ID: 2, Title: "Proces", Author: "Franz Kafka", Rok: 1925},
    {ID: 3, Title: "Mały Książę", Author: "Antoine de Saint-Exupéry", Rok: 1943},
    {ID: 4, Title: "Grona gniewu", Author: "John Steinbeck", Rok: 1939},
    {ID: 5, Title: "Komu bije dzwon", Author: "Ernest Hemingway", Rok: 1940},
    {ID: 6, Title: "Rok 1984", Author: "George Orwell", Rok: 1949},
    {ID: 7, Title: "Mistrz i Małgorzata", Author: "", Rok: 1967},
    {ID: 8, Title: "Imię róży", Author: "Umberto Eco", Rok: 1980},
    {ID: 9, Title: "Czarodziejska Góra", Author: "Tomasz Mann", Rok: 1924},
    {ID: 10, Title: "Dzieci północy", Author: "Salman Rushdie", Rok: 1981}
];

function findAll()
{
    return books;
}

function findById(id)
{
    for (var i in books)
        if (books[i].ID == id)
            return books[i];
    return null;
}

function findByYear(since, to)
{
    var results = [];
    for (var i in books)
        if (books[i].Rok >= since && books[i].Rok <= to)
            results.push(books[i]);
    return results;
}

function create(book)
{
    book.ID = ++count;
    books.push(book);
    return book;
}

function remove(book)
{
    for (var i in books)
        if (books[i].ID == book.ID)
            books.splice(i,1);
}

module.exports.findAll = findAll;
module.exports.findById = findById;
module.exports.findByYear = findByYear;
module.exports.create = create;
module.exports.remove = remove;
